package tud.st.dpf.robot.simulator.main;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import tud.st.dpf.robot.simulator.Simulator;
import tud.st.dpf.robot.simulator.participants.Machine;
import tud.st.dpf.robot.simulator.participants.Order;
import tud.st.dpf.robot.simulator.participants.Person;
import tud.st.dpf.robot.simulator.participants.Product;
import tud.st.dpf.robot.simulator.participants.Qualification;
import tud.st.dpf.robot.simulator.participants.Robot;

public class RobotSimulatorMain {
	
	public static void main(String[] args) {
		List<Robot> robots = new ArrayList<Robot>();
		
		List<Machine> machines = new ArrayList<Machine>();
		machines.add(new Machine("Producing Machine 1", new Product("Product 1", 100)));
		machines.add(new Machine("Producing Machine 2", new Product("Product 2", 1200)));
		machines.add(new Machine("Producing Machine 3", new Product("Product 1", 100)));
		machines.add(new Machine("Producing Machine 4", new Product("Product 2", 1200)));

		robots.add(new Robot("Turtlebot 1", 1000, 2500));
		robots.add(new Robot("KUKA Bot 1", 2000, 3000));
		robots.add(new Robot("Turtlebot 2", 1000, 2500));
		robots.add(new Robot("KUKA Bot 2", 2000, 3000));
		robots.add(new Robot("Turtlebot 3", 1000, 2500));
		robots.add(new Robot("KUKA Bot 3", 2000, 3000));
		
		List<Person> persons = new ArrayList<>();
		persons.add(new Person("Max Mustermann", Qualification.Manager));
		persons.add(new Person("John Doe", Qualification.Engineer));
		
		Simulator s = Simulator.getInstance();
		s.initialize(robots, machines, persons);
		s.processOrder(createOrder());
		s.start();
		
		System.out.println("Press any key to exit");
		try {
			System.in.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		s.stop();
	}
	
	private static Order createOrder(){
		List<Product> products = new ArrayList<Product>();
		
		for(int i = 0; i < 20; i++){
			products.add(new Product("Product 1", 100));
			if(i % 2 == 0)
				products.add(new Product("Product 2", 1200));
		}
			
		
		return new Order(products);
	}

}
