package tud.st.dpf.robot.simulator.participants;

import java.util.ArrayList;
import java.util.List;

public class ChargingStation extends Position {

	private List<Robot> chargingRobots;

	public ChargingStation(String name) {
		super(name);

		chargingRobots = new ArrayList<>();

		new Thread(new Runnable() {

			@Override
			public void run() {
				while (true) {
					for (Robot r : chargingRobots) {
						r.setBatteryLoad(r.getBatteryLoad() + 1);
						
						System.out.println("Robot " + r.getName() + " charged (" + r.getBatteryLoad() + "%)");
					}

					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
		}).start();
	}

	public void charge(Robot r) {
		if (!chargingRobots.contains(r))
			chargingRobots.add(r);
	}

	public void stopCharging(Robot r) {
		chargingRobots.remove(r);
	}

}
